Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type MapKeyColumn

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface MapKeyColumn

Specifies the mapping for the key column of a map whose map key is a basic type. If the `name` element is not specified, it defaults to the concatenation of the following: the name of the referencing relationship field or property; "_"; "KEY".

        Example:

        @Entity
        public class Item {
           @Id int id;
           ...
           @ElementCollection
           @MapKeyColumn(name="IMAGE_NAME")
           @Column(name="IMAGE_FILENAME")
           @CollectionTable(name="IMAGE_MAPPING")
           Map<String, String> images;  // map from image name to filename
           ...
        }

Since:
  Java Persistence 2.0

Optional Element Summary
`java.lang.String` | `columnDefinition` (Optional) The SQL fragment that is used when generating the DDL for the column.
`boolean` | `insertable` (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.
`int` | `length` (Optional) The column length.
`java.lang.String` | `name` (Optional) The name of the map key column.
`boolean` | `nullable` (Optional) Whether the database column is nullable.
`int` | `precision` (Optional) The precision for a decimal (exact numeric) column.
`int` | `scale` (Optional) The scale for a decimal (exact numeric) column.
`java.lang.String` | `table` (Optional) The name of the table that contains the column.
`boolean` | `unique` (Optional) Whether the column is a unique key.
`boolean` | `updatable` (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

### name

    public abstract java.lang.String name

  (Optional) The name of the map key column. The table in which it is found depends upon the context. If the map key is for an element collection, the map key column is in the collection table for the map value. If the map key is for a ManyToMany entity relationship or for a OneToMany entity relationship using a join table, the map key column is in a join table. If the map key is for a OneToMany entity relationship using a foreign key mapping strategy, the map key column is in the table of the entity that is the value of the map.

  Defaults to the concatenation of the following: the name of the referencing relationship field or property; "_"; "`KEY`".

  Default:
    ""

### unique

    public abstract boolean unique

  (Optional) Whether the column is a unique key. This is a shortcut for the `UniqueConstraint` annotation at the table level and is useful for when the unique key constraint corresponds to only a single column. This constraint applies in addition to any constraint entailed by primary key mapping and to constraints specified at the table level.

  Default:
    false

### nullable

    public abstract boolean nullable

  (Optional) Whether the database column is nullable.

  Default:
    false

### insertable

    public abstract boolean insertable

  (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.

  Default:
    true

### updatable

    public abstract boolean updatable

  (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

  Default:
    true

### columnDefinition

    public abstract java.lang.String columnDefinition

  (Optional) The SQL fragment that is used when generating the DDL for the column.

  Defaults to the generated SQL to create a column of the inferred type.

  Default:
    ""

### table

    public abstract java.lang.String table

  (Optional) The name of the table that contains the column.

  Defaults: If the map key is for an element collection, the name of the collection table for the map value. If the map key is for a OneToMany or ManyToMany entity relationship using a join table, the name of the join table for the map. If the map key is for a OneToMany entity relationship using a foreign key mapping strategy, the name of the primary table of the entity that is the value of the map.

  Default:
    ""

### length

    public abstract int length

  (Optional) The column length. (Applies only if a string-valued column is used.)

  Default:
    255

### precision

    public abstract int precision

  (Optional) The precision for a decimal (exact numeric) column. (Applies only if a decimal column is used.)

  Default: 0. (The value must be set by the developer.)

  Default:
    0

### scale

    public abstract int scale

  (Optional) The scale for a decimal (exact numeric) column. (Applies only if a decimal column is used.)

  Default:
    0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT